## gitaly 13.4.6+dfsg1

=== Makefile ===
# Makefile for Gitaly

# You can override options by creating a "config.mak" file in Gitaly's root
# directory.
-include config.mak

# Call `make V=1` in order to print commands verbosely.
ifeq ($(V),1)
    Q =
else
    Q = @
endif

SHELL = /usr/bin/env bash -eo pipefail

# Host information
OS   := $(shell uname)
ARCH := $(shell uname -m)

# Directories
SOURCE_DIR       := $(abspath $(dir $(lastword ${MAKEFILE_LIST})))
BUILD_DIR        := ${SOURCE_DIR}/_build
COVERAGE_DIR     := ${BUILD_DIR}/cover
GITALY_RUBY_DIR  := ${SOURCE_DIR}/ruby
GITLAB_SHELL_DIR := ${GITALY_RUBY_DIR}/gitlab-shell

# These variables may be overridden at runtime by top-level make
PREFIX           ?= /usr/local
prefix           ?= ${PREFIX}
exec_prefix      ?= ${prefix}
bindir           ?= ${exec_prefix}/bin
INSTALL_DEST_DIR := ${DESTDIR}${bindir}
ASSEMBLY_ROOT    ?= ${BUILD_DIR}/assembly
GIT_PREFIX       ?= ${GIT_INSTALL_DIR}

# Tools
GIT               := $(shell which git)
GOIMPORTS         := ${BUILD_DIR}/bin/goimports
GITALYFMT         := ${BUILD_DIR}/bin/gitalyfmt
GOLANGCI_LINT     := ${BUILD_DIR}/bin/golangci-lint
GO_LICENSES       := ${BUILD_DIR}/bin/go-licenses
PROTOC            := ${BUILD_DIR}/protoc/bin/protoc
PROTOC_GEN_GO     := ${BUILD_DIR}/bin/protoc-gen-go
PROTOC_GEN_GITALY := ${BUILD_DIR}/bin/protoc-gen-gitaly
GO_JUNIT_REPORT   := ${BUILD_DIR}/bin/go-junit-report
GOCOVER_COBERTURA := ${BUILD_DIR}/bin/gocover-cobertura

# Build information
BUNDLE_FLAGS    ?= $(shell test -f ${SOURCE_DIR}/../.gdk-install-root && echo --no-deployment || echo --deployment)
GITALY_PACKAGE  := gitlab.com/gitlab-org/gitaly
BUILD_TIME      := $(shell date +"%Y%m%d.%H%M%S")
GITALY_VERSION  := $(shell git describe --match v* 2>/dev/null | sed 's/^v//' || cat ${SOURCE_DIR}/VERSION 2>/dev/null || echo unknown)
GO_LDFLAGS      := -ldflags '-X ${GITALY_PACKAGE}/internal/version.version=${GITALY_VERSION} -X ${GITALY_PACKAGE}/internal/version.buildtime=${BUILD_TIME}'
GO_TEST_LDFLAGS := -X gitlab.com/gitlab-org/gitaly/auth.timestampThreshold=5s
GO_BUILD_TAGS   := tracer_static,tracer_static_jaeger,continuous_profiler_stackdriver,static,system_libgit2

# Dependency versions
GOLANGCI_LINT_VERSION     ?= 1.27.0
PROTOC_VERSION            ?= 3.12.4
PROTOC_GEN_GO_VERSION     ?= 1.3.2
GIT_VERSION               ?= v2.28.0
GIT2GO_VERSION            ?= v30
LIBGIT2_VERSION       	  ?= v1.0.1
GOCOVER_COBERTURA_VERSION ?= aaee18c8195c3f2d90e5ef80ca918d265463842a

# Dependency downloads
ifeq (${OS},Darwin)
    PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-osx-x86_64.zip
    PROTOC_HASH           ?= 210227683a5db4a9348cd7545101d006c5829b9e823f3f067ac8539cb387519e
else ifeq (${OS},Linux)
    PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-linux-x86_64.zip
    PROTOC_HASH           ?= d0d4c7a3c08d3ea9a20f94eaface12f5d46d7b023fe2057e834a4181c9e93ff3
endif

# Git target
GIT_REPO_URL      ?= https://gitlab.com/gitlab-org/gitlab-git.git
GIT_BINARIES_URL  ?= https://gitlab.com/gitlab-org/gitlab-git/-/jobs/artifacts/${GIT_VERSION}/raw/git_full_bins.tgz?job=build
GIT_BINARIES_HASH ?= 6609d175609ac48899971693e615aee1c5fac8bd7b18e14a95f97572e5128e50
GIT_INSTALL_DIR   := ${BUILD_DIR}/git
GIT_SOURCE_DIR    := ${BUILD_DIR}/src/git

ifeq (${GIT_BUILD_OPTIONS},)
    # activate developer checks
    GIT_BUILD_OPTIONS += DEVELOPER=1
    # make it easy to debug in case of crashes
    GIT_BUILD_OPTIONS += CFLAGS='-O0 -g3'
    GIT_BUILD_OPTIONS += USE_LIBPCRE2=YesPlease
    GIT_BUILD_OPTIONS += NO_PERL=YesPlease
    GIT_BUILD_OPTIONS += NO_EXPAT=YesPlease
    GIT_BUILD_OPTIONS += NO_TCLTK=YesPlease
    # fix compilation on musl libc
    GIT_BUILD_OPTIONS += NO_REGEX=YesPlease
    GIT_BUILD_OPTIONS += NO_GETTEXT=YesPlease
    GIT_BUILD_OPTIONS += NO_PYTHON=YesPlease
    GIT_BUILD_OPTIONS += NO_INSTALL_HARDLINKS=YesPlease
    GIT_BUILD_OPTIONS += NO_R_TO_GCC_LINKER=YesPlease
endif

# libgit2 target
LIBGIT2_REPO_URL    ?= https://gitlab.com/libgit2/libgit2
LIBGIT2_SOURCE_DIR  ?= ${BUILD_DIR}/src/libgit2
LIBGIT2_BUILD_DIR   ?= ${LIBGIT2_SOURCE_DIR}/build
LIBGIT2_INSTALL_DIR ?= ${BUILD_DIR}/libgit2

ifeq (${LIBGIT2_BUILD_OPTIONS},)
    LIBGIT2_BUILD_OPTIONS += -DTHREADSAFE=ON
    LIBGIT2_BUILD_OPTIONS += -DBUILD_CLAR=OFF
    LIBGIT2_BUILD_OPTIONS += -DBUILD_SHARED_LIBS=OFF
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_C_FLAGS=-fPIC
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_BUILD_TYPE=Release
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_INSTALL_PREFIX=${LIBGIT2_INSTALL_DIR}
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_INSTALL_LIBDIR=lib
    LIBGIT2_BUILD_OPTIONS += -DENABLE_TRACE=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_SSH=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_HTTPS=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_ICONV=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_NTLMCLIENT=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_BUNDLED_ZLIB=ON
    LIBGIT2_BUILD_OPTIONS += -DUSE_HTTP_PARSER=builtin
    LIBGIT2_BUILD_OPTIONS += -DREGEX_BACKEND=builtin
endif

# These variables control test options and artifacts
TEST_OPTIONS     ?=
TEST_REPORT_DIR  ?= ${BUILD_DIR}/reports
TEST_OUTPUT_NAME ?= go-${GO_VERSION}-git-${GIT_VERSION}
TEST_OUTPUT      ?= ${TEST_REPORT_DIR}/go-tests-output-${TEST_OUTPUT_NAME}.txt
TEST_REPORT      ?= ${TEST_REPORT_DIR}/go-tests-report-${TEST_OUTPUT_NAME}.xml
TEST_EXIT        ?= ${TEST_REPORT_DIR}/go-tests-exit-${TEST_OUTPUT_NAME}.txt
TEST_REPO_DIR    := ${SOURCE_DIR}/internal/testhelper/testdata/data
TEST_REPO        := ${TEST_REPO_DIR}/gitlab-test.git
TEST_REPO_GIT    := ${TEST_REPO_DIR}/gitlab-git-test.git

# Find all commands.
find_commands         = $(notdir $(shell find ${SOURCE_DIR}/cmd -mindepth 1 -maxdepth 1 -type d -print))
# Find all command binaries.
find_command_binaries = $(addprefix ${BUILD_DIR}/bin/, $(call find_commands))

# Find all Go source files.
find_go_sources  = $(shell find ${SOURCE_DIR} -type d \( -name ruby -o -name vendor -o -name testdata -o -name '_*' -o -path '*/proto/go' \) -prune -o -type f -name '*.go' -not -name '*.pb.go' -print | sort -u)
# Find all Go packages.
find_go_packages = $(dir $(call find_go_sources, 's|[^/]*\.go||'))

unexport GOROOT
export GOBIN                      = ${BUILD_DIR}/bin
export GOPROXY                   ?= https://proxy.golang.org
export PATH                      := ${BUILD_DIR}/bin:${PATH}
export PKG_CONFIG_PATH           := ${LIBGIT2_INSTALL_DIR}/lib/pkgconfig
export GITALY_TESTING_GIT_BINARY ?= ${GIT_INSTALL_DIR}/bin/git

.NOTPARALLEL:

.PHONY: all
all: INSTALL_DEST_DIR = ${SOURCE_DIR}
all: install

.PHONY: build
build: ${SOURCE_DIR}/.ruby-bundle libgit2
	go install ${GO_LDFLAGS} -tags "${GO_BUILD_TAGS}" $(addprefix ${GITALY_PACKAGE}/cmd/, $(call find_commands))

.PHONY: install
install: build
	${Q}mkdir -p ${INSTALL_DEST_DIR}
	install $(call find_command_binaries) ${INSTALL_DEST_DIR}

.PHONY: force-ruby-bundle
force-ruby-bundle:
	${Q}rm -f ${SOURCE_DIR}/.ruby-bundle

# Assembles all runtime components into a directory
# Used by the GDK: run 'make assemble ASSEMBLY_ROOT=.../gitaly'
.PHONY: assemble
assemble: force-ruby-bundle assemble-internal

# assemble-internal does not force 'bundle install' to run again
.PHONY: assemble-internal
assemble-internal: assemble-ruby assemble-go

.PHONY: assemble-go
assemble-go: build
	${Q}rm -rf ${ASSEMBLY_ROOT}/bin
	${Q}mkdir -p ${ASSEMBLY_ROOT}/bin
	install $(call find_command_binaries) ${ASSEMBLY_ROOT}/bin

.PHONY: assemble-ruby
assemble-ruby:
	${Q}mkdir -p ${ASSEMBLY_ROOT}
	${Q}rm -rf ${GITALY_RUBY_DIR}/tmp ${GITLAB_SHELL_DIR}/tmp
	${Q}mkdir -p ${ASSEMBLY_ROOT}/ruby/
	rsync -a --delete  ${GITALY_RUBY_DIR}/ ${ASSEMBLY_ROOT}/ruby/
	${Q}rm -rf ${ASSEMBLY_ROOT}/ruby/spec ${ASSEMBLY_ROOT}/ruby/gitlab-shell/spec ${ASSEMBLY_ROOT}/ruby/gitlab-shell/gitlab-shell.log

.PHONY: binaries
binaries: assemble
	${Q}if [ ${ARCH} != 'x86_64' ]; then echo Incorrect architecture for build: ${ARCH}; exit 1; fi
	${Q}cd ${ASSEMBLY_ROOT} && sha256sum bin/* | tee checksums.sha256.txt

.PHONY: prepare-tests
prepare-tests: git ${GITLAB_SHELL_DIR}/config.yml ${TEST_REPO} ${TEST_REPO_GIT} ${SOURCE_DIR}/.ruby-bundle

.PHONY: test
test: export PATH := ${SOURCE_DIR}/internal/testhelper/testdata/home/bin:${PATH}
test: test-go rspec rspec-gitlab-shell

.PHONY: test-go
test-go: prepare-tests ${GO_JUNIT_REPORT} libgit2
	${Q}mkdir -p ${TEST_REPORT_DIR}
	${Q}echo 0 >${TEST_EXIT}
	${Q}go test ${TEST_OPTIONS} -v -tags "${GO_BUILD_TAGS}" -ldflags='${GO_TEST_LDFLAGS}' -count=1 $(call find_go_packages) 2>&1 | tee ${TEST_OUTPUT} || echo $$? >${TEST_EXIT}
	${Q}${GO_JUNIT_REPORT} <${TEST_OUTPUT} >${TEST_REPORT}
	${Q}exit `cat ${TEST_EXIT}`

.PHONY: test-with-proxies
test-with-proxies: prepare-tests
	${Q}go test -tags "${GO_BUILD_TAGS}" -count=1  -exec ${SOURCE_DIR}/_support/bad-proxies ${GITALY_PACKAGE}/internal/gitaly/rubyserver/

.PHONY: test-with-praefect
test-with-praefect: build prepare-tests
	${Q}GITALY_TEST_PRAEFECT_BIN=${BUILD_DIR}/bin/praefect go test -tags "${GO_BUILD_TAGS}" -ldflags='${GO_TEST_LDFLAGS}' -count=1 $(call find_go_packages) # count=1 bypasses go 1.10 test caching

.PHONY: race-go
race-go: TEST_OPTIONS = -race
race-go: test-go

.PHONY: rspec
rspec: assemble-go prepare-tests
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec rspec

.PHONY: rspec-gitlab-shell
rspec-gitlab-shell: ${GITLAB_SHELL_DIR}/config.yml assemble-go prepare-tests
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec bin/ruby-cd ${GITLAB_SHELL_DIR} rspec

.PHONY: test-postgres
test-postgres: prepare-tests
	${Q}go test -tags "${GO_BUILD_TAGS}",postgres -count=1 gitlab.com/gitlab-org/gitaly/internal/praefect/...

.PHONY: verify
verify: check-mod-tidy check-formatting notice-up-to-date check-proto rubocop

.PHONY: check-mod-tidy
check-mod-tidy:
	${Q}${GIT} diff --quiet --exit-code go.mod go.sum || (echo "error: uncommitted changes in go.mod or go.sum" && exit 1)
	${Q}go mod tidy
	${Q}${GIT} diff --quiet --exit-code go.mod go.sum || (echo "error: uncommitted changes in go.mod or go.sum" && exit 1)

.PHONY: lint
lint: ${GOLANGCI_LINT} libgit2
	${Q}${GOLANGCI_LINT} cache clean && ${GOLANGCI_LINT} run --build-tags "${GO_BUILD_TAGS}" --out-format tab --config ${SOURCE_DIR}/.golangci.yml

.PHONY: check-formatting
check-formatting: ${GITALYFMT}
	${Q}${GITALYFMT} $(call find_go_sources) | awk '{ print } END { if(NR>0) { print "Formatting error, run make format"; exit(1) } }'

.PHONY: format
format: ${GOIMPORTS} ${GITALYFMT}
	${Q}${GOIMPORTS} -w -l $(call find_go_sources)
	${Q}${GITALYFMT} -w $(call find_go_sources)
	${Q}${GOIMPORTS} -w -l $(call find_go_sources)

.PHONY: staticcheck-deprecations
staticcheck-deprecations: ${GOLANGCI_LINT}
	${Q}${GOLANGCI_LINT} run --build-tags "${GO_BUILD_TAGS}" --out-format tab --config ${SOURCE_DIR}/_support/golangci.warnings.yml

.PHONY: lint-warnings
lint-warnings: staticcheck-deprecations

.PHONY: notice-up-to-date
notice-up-to-date: ${BUILD_DIR}/NOTICE
	${Q}(cmp ${BUILD_DIR}/NOTICE ${SOURCE_DIR}/NOTICE) || (echo >&2 "NOTICE requires update: 'make notice'" && false)

.PHONY: notice
notice: ${SOURCE_DIR}/NOTICE

.PHONY: clean
clean:
	rm -rf ${BUILD_DIR} ${SOURCE_DIR}/internal/testhelper/testdata/data/ ${SOURCE_DIR}/ruby/.bundle/ ${SOURCE_DIR}/ruby/gitlab-shell/config.yml ${SOURCE_DIR}/ruby/vendor/bundle/ $(addprefix ${SOURCE_DIR}/, $(notdir $(call find_commands)))

.PHONY: clean-ruby-vendor-go
clean-ruby-vendor-go:
	mkdir -p ${SOURCE_DIR}/ruby/vendor && find ${SOURCE_DIR}/ruby/vendor -type f -name '*.go' -delete

.PHONY: check-proto
check-proto: proto no-proto-changes

.PHONY: rubocop
rubocop: ${SOURCE_DIR}/.ruby-bundle
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec rubocop --parallel

.PHONY: cover
cover: prepare-tests libgit2 ${GOCOVER_COBERTURA}
	${Q}echo "NOTE: make cover does not exit 1 on failure, don't use it to check for tests success!"
	${Q}mkdir -p "${COVERAGE_DIR}"
	${Q}rm -f "${COVERAGE_DIR}/all.merged" "${COVERAGE_DIR}/all.html"

=== internal/praefect/Makefile ===
mock/mock.pb.go: mock/mock.proto
	protoc --go_out=paths=source_relative,plugins=grpc:./mock -I$(shell pwd)/../../proto -I$(shell pwd)/mock $(shell pwd)/mock/*.proto
	goimports -w mock/mock.pb.go

=== internal/middleware/cache/Makefile ===
testdata/%.pb.go: testdata/%.proto
	protoc --go_out=paths=source_relative,plugins=grpc:./testdata -I${shell pwd}/../../../proto/ -I$(shell pwd)/testdata $(shell pwd)/testdata/*.proto

=== debian/changelog ===
gitaly (13.4.6+dfsg1-2) unstable; urgency=medium

  * Reupload to unstable
  * Bump Standards-Version to 4.5.1 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Tue, 01 Dec 2020 20:22:20 +0530

gitaly (13.4.6+dfsg1-1) experimental; urgency=medium

  [ Pirate Praveen ]
  * New upstream version 13.4.6+dfsg
  * Refresh patches
  * Add new build dependency on golang-honnef-go-tools-dev
  * Update build dependencies
  * New upstream version 13.4.6+dfsg1 (drop embedded copy of gitaly client)

  [ Sruthi Chandran ]
  * Update minimum version for deps and builddeps

 -- Sruthi Chandran <srud@debian.org>  Fri, 27 Nov 2020 02:06:49 +0530

=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
 golang-any (>= 2:1.13~),
 gitlab-shell (>= 13.7~),
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-client9-reopen-dev,
 golang-github-cloudflare-tableflip-dev (>= 1.2~),
 golang-github-davecgh-go-spew-dev,
 golang-github-dchest-safefile-dev,
 golang-goprotobuf-dev (>= 1.3~),
#~ golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
 golang-github-google-uuid-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-protobuf-extensions-dev,
#~ golang-github-getsentry-raven-go-dev,
 golang-github-lib-pq-dev (>= 1.3~),
 golang-github-pmezard-go-difflib-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-rubenv-sql-migrate-dev,
 golang-github-sebest-xff-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-github-stretchr-testify-dev (>= 1.4~),
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.22~),
#~ golang-google-genproto-dev,
 golang-honnef-go-tools-dev,
 golang-procfs-dev,
 golang-gopkg-gorp.v1-dev,
 golang-gopkg-libgit2-git2go.v28-dev,
 golang-gopkg-yaml.v2-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
 gem2deb,
 ruby-bundler,
 ruby-rugged (>= 0.28.1~),
 ruby-github-linguist (>= 7.9~),
 ruby-github-markup (>= 1.7.0~),
 ruby-activesupport (>= 2:6.0.3~),
 ruby-gollum-lib (>= 4.2.7.9-2~),
 ruby-gollum-rugged-adapter (>= 0.4.4.2~),
 ruby-grpc (>= 1.24~),
 ruby-grpc-tools (>= 1.24~),
 ruby-sentry-raven (>= 3.0~),
 ruby-faraday (>= 0.12~),
 ruby-rbtrace,
 ruby-gitlab-labkit (>= 0.12~),
 ruby-licensee (>= 8.9~),
 ruby-google-protobuf (>= 3.11.2~)
Standards-Version: 4.5.1
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Ruby-Versions: all
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common (=${source:Version}),
     ruby | ruby-interpreter,
     ruby-bundler,
     ruby-rugged (>= 0.28.1~),
     ruby-github-linguist (>= 7.9~),
     ruby-github-markup (>= 1.7.0~),
     ruby-activesupport (>= 2:6.0.3~),
     ruby-gollum-lib (>= 4.2.7.9-2~),
     ruby-gollum-rugged-adapter (>= 0.4.4.2~),
     ruby-grpc (>= 1.24~),
     ruby-sentry-raven (>= 3.0~),
     ruby-faraday (>= 0.12~),
     ruby-rbtrace,
     ruby-gitlab-labkit (>= 0.12~),
     ruby-licensee (>= 8.9~),
     ruby-google-protobuf (>= 3.11.2~),
# sysv deps:
     pipexec,
     procps
Conflicts: libruby2.5
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-google-protobuf (>= 3.1~),
         ruby-grpc (>= 1.24~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

Package: gitlab-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 ruby | ruby-interpreter,
 adduser (>= 3.34~),
 git (>= 1:2.24~),
 ucf,
 gitlab-shell (>= 13.7~)
Description: git powered software platform to collaborate on code (common)
 gitlab provides web based interface to host source code and track issues.
 It allows anyone for fork a repository and send merge requests. Code review
 is possible using merge request workflow. Using groups and roles project
 access can be controlled.
 .
 This package includes configurations common to gitlab and gitaly.

## gitaly 15.4.2+dfsg

=== debian/changelog ===
gitaly (15.4.2+dfsg-1) experimental; urgency=medium

  * New upstream version 15.4.2+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Sun, 09 Oct 2022 23:54:13 +0530

gitaly (15.3.1+dfsg-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell to 14.10
  * Update minimum version of activesupport to 6.1.6.1
  * Update gitlab-shell build dependency also to 14.10
  * Update minimum version of golang-github-git-lfs-git-lfs-dev to 3.0~
  * Add golang-gitlab-gitlab-org-gitlab-shell-v14-dev as dependency
  * Use golang git2go v34 to match libgit2 1.5

 -- Pirate Praveen <praveen@debian.org>  Mon, 03 Oct 2022 11:40:09 +0530

gitaly (15.3.1+dfsg-1) experimental; urgency=medium

  * New upstream version 15.3.1+dfsg
  * Refresh patches
  * Remove -v15 suffix from gitaly-git2go executable
  * Update minimum version of ruby-google-protobuf to 3.21

 -- Pirate Praveen <praveen@debian.org>  Sun, 28 Aug 2022 21:04:36 +0530

gitaly (15.2.2+dfsg2-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell
  * Update minimum version of yamux in runtime dependency as well

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Aug 2022 23:10:13 +0530

gitaly (15.2.2+dfsg2-1) experimental; urgency=medium

  [ Nilesh Patra ]
  * Upstream came up with some sort of 'strange axe to grind' to install a
    few binaries mandatorily. It might be simply better to remove the
    stupid go:embed line since we build all binaries anyway, but let's keep
    it for the sake of less patching but it makes sense to get rid of it in
    long run. The way upstream organizes all of it is crazy -- they install
    things with bundler, make a custom build file and build the go libs as
    well with it. They do a horrible, horrible job there.

 -- Pirate Praveen <praveen@debian.org>  Thu, 18 Aug 2022 17:43:54 +0530

gitaly (15.2.2+dfsg1-1) experimental; urgency=medium

  * New upstream version 15.2.2+dfsg (drop vendored modules)
  * Refresh patches
  * Update dependencies

  [ Nilesh Patra ]
  * d/rules: Build more executables (fixes build failure)

 -- Pirate Praveen <praveen@debian.org>  Sun, 14 Aug 2022 22:23:46 +0530

gitaly (15.1.4+dfsg-1) experimental; urgency=medium

  * Update golang-gitlab-gitlab-org-labkit-dev (>= 1.16~)
  * Update golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~)
  * Vendor gitlab-shell version matching go.mod
  * New upstream version 15.1.4+dfsg
  * Update import path to v15

 -- Pirate Praveen <praveen@debian.org>  Sat, 30 Jul 2022 12:59:09 +0200

gitaly (15.0.4+dfsg-1) experimental; urgency=medium

  * New upstream version 15.0.4+dfsg
  * Update dependencies
  * Add golang-github-golang-jwt-jwt-dev as build dependency

 -- Pirate Praveen <praveen@debian.org>  Sun, 17 Jul 2022 11:33:33 +0200

gitaly (14.10.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.10.4+dfsg
  * Refresh patches
  * Add dependency on ruby-gitlab-markup
  * Update path for gitaly-git2go source directory
  * Update minimum version of ruby-activesupport
  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Tue, 28 Jun 2022 01:35:25 +0530

gitaly (14.9.4+dfsg-2) experimental; urgency=medium

  * Update path for ruby-github-linguist languages.json in config.toml

 -- Pirate Praveen <praveen@debian.org>  Mon, 09 May 2022 00:34:29 +0530

gitaly (14.9.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.9.4+dfsg
  * Disable golang tests (hanging)
  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Sun, 08 May 2022 22:22:42 +0530

gitaly (14.8.5+dfsg-1) experimental; urgency=medium

  * New upstream version 14.8.5+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Tue, 05 Apr 2022 16:31:28 +0530

gitaly (14.7.7+dfsg-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Sat, 02 Apr 2022 13:08:44 +0530

gitaly (14.7.7+dfsg-1) experimental; urgency=medium

  * New upstream version 14.7.7+dfsg
  * Add back ruby-grpc dependency to ruby-gitaly

 -- Pirate Praveen <praveen@debian.org>  Fri, 01 Apr 2022 19:40:26 +0530

gitaly (14.7.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.7.4+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Mon, 28 Mar 2022 22:20:15 +0530

gitaly (14.6.3+dfsg-2) experimental; urgency=medium

  * Update minimum version of ruby-gollum-lib (for ruby-sanitize 6.0 compat)

 -- Pirate Praveen <praveen@debian.org>  Mon, 28 Feb 2022 00:27:15 +0530

gitaly (14.6.3+dfsg-1) experimental; urgency=medium

  * New upstream version 14.6.3+dfsg
  * Refresh patches
  * Add dependency on ruby-gitlab-license-finder

 -- Pirate Praveen <praveen@debian.org>  Sat, 22 Jan 2022 13:22:47 +0530

gitaly (14.5.2+dfsg-3) experimental; urgency=medium

  * Team Upload.
  * d/rules: Specify builddirectory for install
    + Populates golang-gitlab-gitlab-org-gitaly-dev with
      relevant files which was otherwise empty.

 -- Nilesh Patra <nilesh@debian.org>  Wed, 12 Jan 2022 17:01:33 +0000

gitaly (14.5.2+dfsg-2) experimental; urgency=medium

  * Update minimum version of ruby-rugged to 1.2
  * Update minimum version of gitlab-shell to 13.22.1

 -- Pirate Praveen <praveen@debian.org>  Fri, 17 Dec 2021 12:55:22 +0530

gitaly (14.5.2+dfsg-1) experimental; urgency=medium

  * New upstream version 14.5.2+dfsg
  * Refresh patches
  * Update libgit2/git2go dependency

 -- Pirate Praveen <praveen@debian.org>  Sat, 11 Dec 2021 22:01:12 +0530

gitaly (14.4.4+dfsg-1) experimental; urgency=medium

  [ Sahil Dhiman ]
  * Update control to update min version of ruby-activesupport

  [ Pirate Praveen ]
  * New upstream version 14.4.4+dfsg

 -- Pirate Praveen <praveen@debian.org>  Tue, 07 Dec 2021 21:52:48 +0530

gitaly (14.4.2+dfsg-2) experimental; urgency=medium

  * Update minimum version of golang-any to 2:1.17


=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
# See #1016217 (gccgo and x/net don't work well together right now)
# golang-any (>= 2:1.17~),
 golang-go (>= 2:1.17~),
 golang-github-beevik-ntp-dev,
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-client9-reopen-dev,
 golang-github-cloudflare-tableflip-dev (>= 1.2~),
 golang-github-containerd-cgroups-dev,
 golang-github-davecgh-go-spew-dev,
 golang-github-dchest-safefile-dev,
 golang-github-getsentry-sentry-go-dev,
 golang-github-golang-jwt-jwt-dev,
 golang-github-git-lfs-git-lfs-dev (>= 3.0~),
 golang-github-google-uuid-dev,
 golang-github-go-enry-go-license-detector-dev,
 golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
 golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
 golang-github-hashicorp-golang-lru-dev,
 golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
 golang-github-jackc-pgconn-dev,
 golang-github-jackc-pgx-v4-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-github-lib-pq-dev (>= 1.3~),
 golang-github-opencontainers-specs-dev,
 golang-github-oklog-ulid-dev (>= 2.0~),
 golang-github-pelletier-go-toml.v2-dev,
 golang-github-pmezard-go-difflib-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-rubenv-sql-migrate-dev,
 golang-github-sebest-xff-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-github-stretchr-testify-dev (>= 1.4~),
 golang-gitlab-gitlab-org-gitlab-shell-v14-dev,
 golang-gitlab-gitlab-org-labkit-dev (>= 1.16~),
 golang-gocloud-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.38.0-3~),
 golang-google-protobuf-dev,
 golang-gopkg-gorp.v1-dev,
 golang-github-libgit2-git2go-v34-dev,
 golang-gopkg-yaml.v2-dev,
 golang-goprotobuf-dev (>= 1.5~),
 golang-honnef-go-tools-dev,
 golang-procfs-dev,
 golang-protobuf-extensions-dev,
 golang-uber-goleak-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
 gem2deb,
 ruby-bundler,
 ruby-rugged (>= 1.2~),
 ruby-github-linguist (>= 7.20~),
 ruby-gitlab-markup (>= 1.7.1~),
 ruby-github-markup (>= 1.7.0~),
 ruby-gitlab-license-finder,
 ruby-activesupport (>= 2:6.1.6.1~),
 ruby-gollum-lib (>= 4.2.7.10~gitlab.2~),
 ruby-gollum-rugged-adapter (>= 0.4.4.4~),
 ruby-grpc (>= 1.42~),
 ruby-grpc-tools (>= 1.42~),
 ruby-sentry-raven (>= 3.0~),
 ruby-faraday (>= 0.12~),
 ruby-rbtrace,
 ruby-gitlab-labkit (>= 0.24~),
 ruby-licensee (>= 9.15~),
 ruby-google-protobuf (>= 3.21~)
Standards-Version: 4.6.1
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Ruby-Versions: all
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly/v15

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common (=${source:Version}),
     ruby | ruby-interpreter,
     ruby-bundler,
     ruby-rugged (>= 1.2~),
     ruby-github-linguist (>= 7.20~),
     ruby-gitlab-markup (>= 1.7.1~),
     ruby-github-markup (>= 1.7.0~),
     ruby-gitlab-license-finder,
     ruby-activesupport (>= 2:6.1.6.1~),
     ruby-gollum-lib (>= 4.2.7.10~gitlab.2~),
     ruby-gollum-rugged-adapter (>= 0.4.4.4~),
     ruby-grpc (>= 1.42~),
     ruby-google-protobuf (>= 3.21~),
     ruby-sentry-raven (>= 3.0~),
     ruby-faraday (>= 0.12~),
     ruby-rbtrace,
     ruby-gitlab-labkit (>= 0.24~),
     ruby-licensee (>= 9.15~),
# sysv deps:
     pipexec,
     procps
Conflicts: libruby2.5
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-grpc (>= 1.0~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

Package: gitlab-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 ruby | ruby-interpreter,
 adduser (>= 3.34~),
 git (>= 1:2.33~),
 ucf,
 gitlab-shell (>= 14.10~)
Description: git powered software platform to collaborate on code (common)
 gitlab provides web based interface to host source code and track issues.
 It allows anyone for fork a repository and send merge requests. Code review
 is possible using merge request workflow. Using groups and roles project
 access can be controlled.
 .
 This package includes configurations common to gitlab and gitaly.

Package: golang-gitlab-gitlab-org-gitaly-dev
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         golang-github-beevik-ntp-dev,
         golang-github-beorn7-perks-dev,
         golang-github-burntsushi-toml-dev,
         golang-github-client9-reopen-dev,
         golang-github-cloudflare-tableflip-dev (>= 1.2~),
         golang-github-containerd-cgroups-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-dchest-safefile-dev,
         golang-github-getsentry-sentry-go-dev,
         golang-github-git-lfs-git-lfs-dev (>= 3.0~),
         golang-github-google-uuid-dev,
         golang-github-go-enry-go-license-detector-dev,
         golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
         golang-github-hashicorp-golang-lru-dev,
         golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
         golang-github-jackc-pgconn-dev,
         golang-github-jackc-pgx-v4-dev,
         golang-github-kelseyhightower-envconfig-dev,
         golang-github-lib-pq-dev (>= 1.3~),
         golang-github-opencontainers-specs-dev,
         golang-github-oklog-ulid-dev (>= 2.0~),
         golang-github-pelletier-go-toml.v2-dev,
         golang-github-pmezard-go-difflib-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-prometheus-client-model-dev,
         golang-github-prometheus-common-dev,
         golang-github-rubenv-sql-migrate-dev,
         golang-github-sebest-xff-dev,
         golang-github-sirupsen-logrus-dev (>= 1.0~),
         golang-github-stretchr-testify-dev (>= 1.4~),
         golang-gitlab-gitlab-org-gitlab-shell-v14-dev,
         golang-gitlab-gitlab-org-labkit-dev,
         golang-gocloud-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-golang-x-tools,
         golang-google-grpc-dev (>= 1.38.0-3~),
         golang-google-protobuf-dev,
         golang-gopkg-gorp.v1-dev,
         golang-github-libgit2-git2go-v34-dev,
         golang-gopkg-yaml.v2-dev,
         golang-goprotobuf-dev (>= 1.5~),
         golang-honnef-go-tools-dev,
         golang-procfs-dev,
         golang-protobuf-extensions-dev,
         golang-uber-goleak-dev,
Description: Gitaly golang module
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.
 .
 This package provides golang module of gitaly.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_GOLANG_GO_GENERATE := 1
#export DH_GOLANG_INSTALL_ALL := 1  # test data
#export DH_GOLANG_INSTALL_EXTRA := vendor
export DH_RUBY = --gem-install
export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-gitaly
export GEM2DEB_TEST_RUNNER = --check-dependencies
export RAILS_ENV = development # for bundle install --local test
export GITALY_EXECUTABLES = $(addprefix gitlab.com/gitlab-org/gitaly/v15/cmd/,$(notdir $(shell find ${CURDIR}/cmd -mindepth 1 -maxdepth 1 -type d -print)))
# All executables packed inside the Gitaly binary.
export GITALY_PACKED_EXECUTABLES = $(filter %gitaly-hooks %gitaly-git2go %gitaly-ssh %gitaly-lfs-smudge, ${GITALY_EXECUTABLES})

include /usr/share/dpkg/pkg-info.mk
## Set some build variables as per Makefile:
VERSION  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")
PKG := gitlab.com/gitlab-org/gitaly/v15
MODULE_VERSION := v15
GO_LDFLAGS ?= -X $(PKG)/internal/version.version=$(VERSION) -X $(PKG)/internal/version.moduleVersion=$(MODULE_VERSION)
GO_BUILD_TAGS ?= static,system_libgit2

%:
	dh $@  --buildsystem=golang --with=golang --package=golang-gitlab-gitlab-org-gitaly-dev \
	--builddirectory=_build
	dh $@  --buildsystem=ruby --with=ruby --package=ruby-gitaly
	dh $@  --package=gitlab-common
	dh $@  --package=gitaly

override_dh_auto_clean:
	rm -rf ruby/proto/gitaly/*_pb.rb
	dh_auto_clean -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build
	dh_auto_clean -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build -- \
	   -ldflags "$(GO_LDFLAGS)" -tags "$(GO_BUILD_TAGS)" \
           $(GITALY_PACKED_EXECUTABLES)
	mkdir -p _build/src/${PKG}/_build/ && cp -a _build/bin _build/src/${PKG}/_build/
	dh_auto_build -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build -- \
	   -ldflags "$(GO_LDFLAGS)" -tags "$(GO_BUILD_TAGS)" \
           gitlab.com/gitlab-org/gitaly/v15/cmd/gitaly
	rm -rf _build/src/${PKG}/_build/
	RAILS_ENV=$(RAILS_ENV) _support/generate-proto-ruby
	dh_auto_build -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	# Test hangs, so don't even run it
	#-dh_auto_test -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	#-O--builddirectory=_build
	dh_auto_test -O--buildsystem=ruby -O--package=ruby-gitaly
	# Test if ruby dependencies are satisfied
	TMPDIR=$$(mktemp -d); cp ruby/Gemfile $$TMPDIR; cd $$TMPDIR;\
        RAILS_ENV=$(RAILS_ENV) bundle install --local || exit 1;\
        rm $$TMPDIR/Gemfile* $$TMPDIR/.bundle/config;\
       	rmdir $$TMPDIR/config; rmdir $$TMPDIR
endif

override_dh_auto_install:
	dh_auto_install -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--no-binaries --builddirectory=_build --destdir=debian/golang-gitlab-gitlab-org-gitaly-dev
	dh_auto_install -O--buildsystem=ruby -O--package=ruby-gitaly --destdir=debian/ruby-gitaly
	$(RM) -rv debian/golang-gitlab-gitlab-org-gitaly-dev/usr/bin
	# Remove testdata, contains files that triggers more lintian errors
	for f in `find debian/ -name testdata`; do \
		$(RM) -rv $$f; \
	done

override_dh_install:
	dh_install
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/Gemfile.lock
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/.gitignore
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/gitlab-shell/.gitignore
